#include "Semaphore.hh"

Semaphore::Semaphore(int val)
: value_(val)
{}

void Semaphore::wait() {
	value_lock_.lock();
	if(value_<=0) {
		value_--;
		condition_.wait(value_lock_);
		value_lock_.unlock();
	} else {
		value_--;
		value_lock_.unlock();
	}
}

void Semaphore::signal() {
	value_lock_.lock();
	if(value_<0) {
		value_++;
		condition_.notify_one();
		value_lock_.unlock();
	} else {
		value_++;
		value_lock_.unlock();
	}
}




